import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { ExpressTemplate, ExpressTemplateParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询运费模板
 */
export async function pageExpressTemplate(params: ExpressTemplateParam) {
  const res = await request.get<ApiResult<PageResult<ExpressTemplate>>>(
    MODULES_API_URL + '/shop/express-template/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询运费模板列表
 */
export async function listExpressTemplate(params?: ExpressTemplateParam) {
  const res = await request.get<ApiResult<ExpressTemplate[]>>(
    MODULES_API_URL + '/shop/express-template',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加运费模板
 */
export async function addExpressTemplate(data: ExpressTemplate) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/express-template',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改运费模板
 */
export async function updateExpressTemplate(data: ExpressTemplate) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/express-template',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除运费模板
 */
export async function removeExpressTemplate(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/express-template/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除运费模板
 */
export async function removeBatchExpressTemplate(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/express-template/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询运费模板
 */
export async function getExpressTemplate(id: number) {
  const res = await request.get<ApiResult<ExpressTemplate>>(
    MODULES_API_URL + '/shop/express-template/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
